# read ascii XY data files
#
# Modified to read x,y or x,y,esd and skip points where y < 0
# Will also read numbers separated by commas, and/or spaces
#
#                                                  BHT Oct 19, 1999
#
# From - Thu Oct 14 18:08:47 1999
# Date: Mon, 11 Oct 1999 17:40:59 -0400
# From: ajm <mcghieaj@esvax.es.dupont.com>
# To: "Brian H. Toby" <brian.toby@nist.gov>
# Subject: Another read file for you if you want it.
#
#Brian,
#	This read file for CMPR reads ascii pairs ( 2theta and intensity ). 
#I don't know if I handled the esd properly, but the program runs.
#
#It appears to be working for me. 
#
#----------------------------------------------------------------
#------- define a command line option -----------------------------
# command line option 
lappend command(cmdopt) -xyd
# proc to use 
set command(-xyd)  readXYdata
#--------define a dialog box entry
# menu label
lappend command(readtypes) "XY data (ascii)"
# proc for this entry
lappend command(readproc) ReadXYd
# allowed data types
if {$tcl_platform(platform) == "windows"} {
    lappend command(filterlist) {asc dat}
    # definitions for these data types
    set command(ReadXYd_asc_type) "XY data"
    set command(ReadXYd_dat_type) "XY data"
} else {
    lappend command(filterlist) {dat ASC asc jones DAT JONES}
    # definitions for these data types
    set command(ReadXYd_dat_type) "XY data"
    set command(ReadXYd_DAT_type) "XY data"
    set command(ReadXYd_asc_type) "XY data"
    set command(ReadXYd_ASC_type) "XY data"
    set command(ReadXYd_jones_type) "XY data"
    set command(ReadXYd_JONES_type) "XY data"
}

proc ReadXYd {file} {
    global command
    if {$file == ""} return
    pleasewait "reading file $file"
    set ret [readXYdata $file]
    donewait
    if {$ret != ""} {return $ret}
    showlastentry $command(read_filelist)

}
proc readXYdata {filename} {

    puts "opening XY Data file $filename"
    global graph

    set lnum 0
    # signal errors by quitting
    if [catch {
	set fp [open $filename r]

       # Great!! Now we are positioned to read the data.

	# Initialize the data structure.
	set data [file root [file tail $filename]] 
	initdata $data
	global ${data}
	set ${data}(xlabel) "2theta"
	set ${data}(xunits) "2theta"
	set ${data}(ylabel) "counts"

	# No missing points
	set ${data}(skip) 0
	set ptsread 0

	# Now, read the rest of the file.
	# until we get to the last data point, an end-of-file or error
	set i 0
	while {[gets $fp line] >= 0} {
	    incr lnum
          # ignore initial lines starting with C
	    if {[string toupper [string range $line 0 0]] == "C" && $ptsread == 0} {
            continue 
          }
            incr i
	    # change commas to blanks 
	    regsub -all , $line " " line
	    if {$lnum > 20000} {
		return "Read too many lines. Something is wrong!"
	    }
	    set yyyy -1
	    catch {
		set xxxx [expr [lindex $line 0]]
		set yyyy [expr [lindex $line 1]]
	    }
	    set yyyyesd -1
	    catch {
		set yyyyesd [expr [lindex $line 2]]
	    }
	    # set the esd
	    if {$yyyyesd < 0} {
		if {$yyyy <= 0} {
		    set yyyyesd 1
		} else {
		   set yyyyesd [expr sqrt(1.0 * $yyyy )] 
		}
	    }
	    # skip negative or garbled points
	    if {[lindex $line 1] >= 0 && $yyyy >= 0} {
		lappend ${data}(x)   $xxxx
		lappend ${data}(y)   $yyyy		
		lappend ${data}(esd) $yyyyesd
	    } else {
		# there are skipped points
		set ${data}(skip) 1
	    }
	    incr ptsread
	}
	if {$ptsread != $i } {return "$ptsread were read, but expected $i points!"}
    } errmsg] {
	# try to process the data we have read
	catch {resetdata $data}
	return "XY Data error. Error reading line $lnum: $errmsg"
    }
    resetdata $data
    lappend graph(plotlist) $data
    catch {close $fp} test
    puts "$ptsread valid points read"
    return {}
}
 
#-- 
#Alistair McGhie [DuPont Exp. Sta.  Wilm. De. 19880-0228]

