# write a comma-separated (spreadsheet-format) file

lappend command(writetypes) ".csv (Spreadsheet)"
lappend command(writeproc) writelistcsv

proc writelistcsv {data} {
    global graph command
    global $data 
    set filename [file join $command(pwd) ${data}.csv]
    set fil [open $filename w]
    if {[set ${data}(type)] == "peaks"} {
	# write a peak file
	puts $fil "twotheta, intensity, wid"
	foreach x   [set ${data}(x)] \
		y   [set ${data}(y)] \
		wid [set ${data}(widths)] {
	    puts $fil "$x, $y, $wid"
	}
    } else {
	# write a data file
	puts $fil "twotheta, intensity, esd"
	if {$command(writeunits) == 0} {
	    foreach x   [set ${data}(x)] \
		    y   [set ${data}(y)] \
		    esd [set ${data}(esd)] {
		puts $fil "$x, $y, $esd"
	    }
	} else {
	    foreach x   [[set ${data}(xvector)] range 0 end] \
		    y   [[set ${data}(yvector)] range 0 end] \
		    esd [[set ${data}(esdvec)]  range 0 end] {
		puts $fil "$x, $y, $esd"
	    }
	}
     }
    close $fil
    return $filename
}
